﻿Imports System.Reflection.Assembly
Public Class frmMain
    Private pasGenFunctions As New pasGenHelper.pasGenFunc
    Public globMaster As String
    Private _pasInfo As String
#Region "Form Events"

    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles Me.Load
        pasGenFunctions.LoadDataSet(DsPass)
        Me.Text &= "_" & FileVersionInfo.GetVersionInfo(GetExecutingAssembly.Location).FileVersion
        Me.Size = New Size(384, 169)
        bsPass.Sort = "DateCreated DESC"
        bsPass.Filter = ""
        txtSearch.Text = My.Resources.txtSearch
        dgvTxtDateCreated.HeaderText = My.Resources.dgvHeaderDate
        dgvTxtInfo.HeaderText = My.Resources.dgvHeaderInfo
        btnClipboard.HeaderText = My.Resources.dgvHeaderClipborad
        btnShowPW.HeaderText = My.Resources.dgvHeaderShowPW
        GenerateToolTips()
        nudPWLength.Value = My.Settings.defPWLength
        niMain.Visible = True
        AddHandler Application.Idle, AddressOf Application_Idle
        If My.Settings.frmAutoHide Then
            tmrMain.Interval = My.Settings.frmAutoHideInt * 60000
            tmrMain.Start()
        End If
    End Sub
    Private Sub Application_Idle(sender As Object, e As EventArgs)
        tmrMain.Stop()
        tmrMain.Interval = My.Settings.frmAutoHideInt * 60000
        tmrMain.Start()
    End Sub
#End Region
#Region "TextBox Events"
    Private Sub txtPass_TextChanged(sender As Object, e As EventArgs) Handles txtPass.TextChanged
        If txtPass.Text.Length <= 0 Then
            btnAcceptPassword.Enabled = False
            pbPwStrength.Image = My.Resources.neutralPW
        Else
            btnAcceptPassword.Enabled = True
            Dim chars = txtPass.Text
            Dim intPwStrength = pasGenFunctions.CheckPasswordStrength(CInt(nudPWLength.Value), chars)
            Select Case intPwStrength
                Case Is <= 2
                    pbPwStrength.Image = My.Resources.lowPW
                Case Is <= 4
                    pbPwStrength.Image = My.Resources.mediumPW
                Case Else
                    pbPwStrength.Image = My.Resources.strongPW
            End Select
        End If
    End Sub
    Private Sub txtSearch_Enter(sender As Object, e As EventArgs) Handles txtSearch.Enter
        txtSearch.Text = ""
        txtSearch.Font = New Font("Segoe UI", 11.25, FontStyle.Regular)
        txtSearch.ForeColor = Color.Black
    End Sub
    Private Sub txtSearch_TextChanged(sender As Object, e As EventArgs) Handles txtSearch.TextChanged
        If txtSearch.Text = My.Resources.txtSearch Then Return
        Search(txtSearch.Text, "Info", bsPass)
    End Sub
    Private Sub txtOwnChars_GotFocus(sender As Object, e As EventArgs) Handles txtOwnChars.GotFocus
        Dim chkBox As CheckBox
        For Each chkBox In panMiddle.Controls
            If TypeOf chkBox Is CheckBox Then
                chkBox.Checked = False
                chkBox.Enabled = False
            End If
        Next
        txtPass.Text = ""
        txtPass.Enabled = False
        btnProposeWPA.Enabled = False
    End Sub
    Private Sub txtOwnChars_TextChanged(sender As Object, e As EventArgs) Handles txtOwnChars.TextChanged
        If txtOwnChars.Text.Length = 0 Then
            btnAcceptPassword.Enabled = False
            txtPass.Text = ""
        Else
            btnProposePasswords.Enabled = True
        End If
    End Sub
#End Region
#Region "DataGridView Events"
    Private Sub dgvPass_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgvPass.CellClick
        If e.RowIndex < 0 OrElse e.RowIndex >= Me.bsPass.Count Then Return
        Dim drv = DirectCast(dgvPass.Rows(e.RowIndex).DataBoundItem, DataRowView)
        Dim rwPass = DirectCast(drv.Row, dsPass.StoredPasswordRow)
        pasGenFunctions.pwDecryption(256, rwPass.Password, globMaster)
        If e.ColumnIndex = 2 Then
            Using logInForm As New frmLogin
                logInForm.Focus()
                logInForm.btnLogin.Text = My.Resources.btnLogin
                If logInForm.ShowDialog() = Windows.Forms.DialogResult.OK Then
                    txtPass.Text = pasGenFunctions.strDecrypted
                    btnAcceptPassword.Enabled = False
                End If
            End Using
        ElseIf e.ColumnIndex = 3 Then
            btnAcceptPassword.Enabled = False
            Clipboard.SetText(pasGenFunctions.strDecrypted)
            niMain.BalloonTipText = My.Resources.strDGVBallonTip
            niMain.ShowBalloonTip(5)
            pasGenFunctions.delClipBoard()
        End If
    End Sub
    Private Sub dgvPass_CellEndEdit(sender As Object, e As DataGridViewCellEventArgs) Handles dgvPass.CellEndEdit
        Me.Validate()
        pasGenFunctions.SaveDataSet(DsPass)
    End Sub
    Private Sub dgvPass_KeyDown(sender As Object, e As KeyEventArgs) Handles dgvPass.KeyDown
        If e.KeyCode = Keys.Back OrElse e.KeyCode = Keys.Delete Then
            Using pasMSG = New frmMSG
                If pasMSG.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                    dgvPass.Rows.Remove(dgvPass.CurrentRow)
                    Me.Validate()
                    pasGenFunctions.SaveDataSet(DsPass)
                End If
            End Using
        Else
            Return
        End If
    End Sub
#End Region
#Region "Button-, CheckBox-, NotifyIcon, Timer-Events"
    Private Sub ckPwChronicle_CheckedChanged(sender As Object, e As EventArgs) Handles ckPwChronicle.CheckedChanged
        Dim stdSize As Size = New Size(384, 169)
        If Me.Size = stdSize Then
            Me.Size = New Size(384, 491)
            ckPwChronicle.Text = My.Resources.strHideChronicle
        Else
            Me.Size = stdSize
            ckPwChronicle.Text = My.Resources.strShowChronicle
        End If
    End Sub
    Private Sub btnPressed_Click(sender As Object, e As EventArgs) Handles btnAcceptPassword.Click, btnClearPW.Click, btnProposePasswords.Click, btnProposeWPA.Click, btnSettings.Click, tsmBtnQuit.Click, tsmAbout.Click
        Select Case True
            Case sender Is btnAcceptPassword : AcceptPassword()
            Case sender Is btnClearPW : CleanUp()
            Case sender Is btnProposePasswords : ProposePasswords()
            Case sender Is btnProposeWPA : ProposeWPA()
            Case sender Is btnSettings : frmSettings.ShowDialog(Me) : btnProposePasswords.Select() : nudPWLength.Value = My.Settings.defPWLength
            Case sender Is tsmBtnQuit : Me.Dispose()
            Case sender Is tsmAbout : frmAbout.ShowDialog(Me) : btnProposePasswords.Select()
        End Select
    End Sub
    Private Sub niMain_MouseClick(sender As Object, e As MouseEventArgs) Handles niMain.MouseClick
        If e.Button = Windows.Forms.MouseButtons.Left Then
            Using logInForm As New frmLogin
                logInForm.Focus()
                logInForm.btnLogin.Text = My.Resources.btnLogin
                If logInForm.ShowDialog() = Windows.Forms.DialogResult.OK Then
                    Me.Visible = True
                    If My.Settings.frmAutoHide Then
                        tmrMain.Interval = My.Settings.frmAutoHideInt * 60000
                        tmrMain.Start()
                    End If
                End If
            End Using
        End If
    End Sub
    Private Sub tmrMain_Tick(sender As Object, e As EventArgs) Handles tmrMain.Tick
        Me.Visible = False
    End Sub
    Private Sub pbDelSearch_Click(sender As Object, e As EventArgs) Handles pbDelSearch.Click
        txtSearch.Font = New Font("Segoe UI", 11.25, FontStyle.Italic)
        txtSearch.ForeColor = Color.Gray
        txtSearch.Text = My.Resources.txtSearch
        bsPass.Filter = ""
        btnProposePasswords.Select()
    End Sub
#End Region
#Region "Subs"
    Private Sub CleanUp()
        Dim chkBox As CheckBox
        For Each chkBox In panMiddle.Controls
            If TypeOf chkBox Is CheckBox Then
                chkBox.Checked = True
                chkBox.Enabled = True
            End If
        Next
        txtPass.Text = ""
        btnAcceptPassword.Enabled = False
        btnProposePasswords.Enabled = True
        btnProposeWPA.Enabled = True
        nudPWLength.Value = My.Settings.defPWLength
        txtOwnChars.Text = ""
        txtPass.Enabled = True
        pbPwStrength.Image = My.Resources.neutralPW
    End Sub
    Private Sub AcceptPassword()
        btnAcceptPassword.Enabled = False
        pasGenFunctions.pwEncryption(256, txtPass.Text, globMaster)
        Me.Validate()
        Using infoFrm As New frmInputInfo
            infoFrm.ShowDialog(Me)
            _pasInfo = infoFrm.txtPWInfo.Text
            DsPass.StoredPassword.AddStoredPasswordRow(pasGenFunctions.strEncrypted, Date.Now, _pasInfo)
            pasGenFunctions.SaveDataSet(DsPass)
            Clipboard.SetText(txtPass.Text)
            niMain.BalloonTipText = My.Resources.strAccPWBallonTip
            niMain.ShowBalloonTip(10)
            CleanUp()
            pasGenFunctions.delClipBoard()
        End Using
    End Sub
    Private Sub ProposePasswords()
        Dim chars As String = ""
        Dim chkBox As CheckBox
        For Each chkBox In panMiddle.Controls
            If TypeOf chkBox Is CheckBox Then
                If chkBox.Checked Then
                    If chkBox.Name = "chkLowerCase" Then
                        chars &= "abcdefghijkmnopqrstuvwxyz"
                    ElseIf chkBox.Name = "chkUpperCase" Then
                        chars &= "ABCDEFGHJKLMNOPQRSTUVWXYZ"
                    ElseIf chkBox.Name = "chkNumbers" Then
                        chars &= "0123456789"
                    ElseIf chkBox.Name = "chkSpecialChar" Then
                        chars &= My.Settings.defSpecChar
                    End If
                End If
            End If
        Next
        If chars.Length = 0 Then chars = "SIMPLE"
        If txtOwnChars.Text.Length > 0 Then chars = txtOwnChars.Text
        txtPass.Text = pasGenFunctions.CreatePassword(CInt(nudPWLength.Value), chars)
        btnAcceptPassword.Enabled = True
    End Sub
    Private Sub ProposeWPA()
        If nudPWLength.Value < 8 Then nudPWLength.Value = 8
        If nudPWLength.Value > 63 Then nudPWLength.Value = 63
        txtPass.Text = pasGenFunctions.CreatePassword(CInt(nudPWLength.Value), "ABCDEFGHJKLMNOPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz0123456789@$?_-=§&")
        btnAcceptPassword.Enabled = True
    End Sub
    Private Sub GenerateToolTips()
        Dim btnStoredPWToolTip As New ToolTip
        btnStoredPWToolTip.AutoPopDelay = 5000
        btnStoredPWToolTip.InitialDelay = 500
        btnStoredPWToolTip.ReshowDelay = 500
        btnStoredPWToolTip.ShowAlways = True
        btnStoredPWToolTip.SetToolTip(Me.btnClearPW, My.Resources.TTbtnClearPW)
        btnStoredPWToolTip.SetToolTip(Me.btnProposePasswords, My.Resources.TTbtnProposePasswords)
        btnStoredPWToolTip.SetToolTip(Me.btnAcceptPassword, My.Resources.TTbtnAcceptPassword)
        btnStoredPWToolTip.SetToolTip(Me.txtPass, My.Resources.TTtxtPass)
        btnStoredPWToolTip.SetToolTip(Me.nudPWLength, My.Resources.TTnudPWLength)
        btnStoredPWToolTip.SetToolTip(Me.ckPwChronicle, My.Resources.TTckPwChronicle)
        btnStoredPWToolTip.SetToolTip(Me.txtOwnChars, My.Resources.TTtxtOwnChars)
        btnStoredPWToolTip.SetToolTip(Me.btnProposeWPA, My.Resources.TTbtnProposeWPA)
        btnStoredPWToolTip.SetToolTip(Me.pbPwStrength, My.Resources.TTpbPWStrength)
        btnStoredPWToolTip.SetToolTip(Me.btnSettings, My.Resources.TTstrSettings)
        Dim chkBox As CheckBox
        For Each chkBox In panMiddle.Controls
            If TypeOf chkBox Is CheckBox Then
                btnStoredPWToolTip.SetToolTip(chkBox, My.Resources.TTchkBox)
            End If
        Next
    End Sub
    Private Sub Search(ByVal searchText As String, ByVal searchString As String, ByVal bs As BindingSource)
        bs.Filter = searchString & " like '%" & searchText & "%'" 
    End Sub

    Private Sub lblHide_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles lblHide.LinkClicked
        Me.Visible = False
        tmrMain.Stop()
        CleanUp()
    End Sub
#End Region
End Class
